// FNDDisplay.cpp: implementation of the CFNDDisplay class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TZSeries.h"
#include "FNDDisplay.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFNDDisplay::CFNDDisplay()
{
	m_pWnd = NULL;
	m_Color = 0;
}

CFNDDisplay::~CFNDDisplay()
{
	Close();
}

void CFNDDisplay::Close()
{
	if(!m_pWnd) return;

	m_Color = 0;
	m_MemDCFND.SelectObject(m_pOldBitmapFND);
	m_MemDC.SelectObject(m_pOldBitmap);
	m_pWnd->ReleaseDC(m_pDC);

	m_pWnd = NULL;
}

CFNDDisplay::SetFrame(CWnd *pWnd)
{
	m_pWnd = NULL;

	// ----
	m_pWnd = pWnd;
	m_pDC = m_pWnd->GetDC();
	m_pWnd->GetClientRect(m_Rect);

	m_MemDC.CreateCompatibleDC(m_pDC);
	m_Bitmap.CreateCompatibleBitmap(m_pDC, m_Rect.Width(), m_Rect.Height());
	m_pOldBitmap = (CBitmap*)m_MemDC.SelectObject(&m_Bitmap);

	m_MemDCFND.CreateCompatibleDC(&m_MemDC);
	m_BitmapFND.LoadBitmap(IDB_BITMAP_FND);
	m_pOldBitmapFND = (CBitmap*)m_MemDCFND.SelectObject(&m_BitmapFND);
}

int CFNDDisplay::MapIndex(int ch)
{
	char map[20] = {".0123456789- "};

	for(int i=0;i<13;i++) if(ch==map[i]) return i;

	return 12;
}

void CFNDDisplay::Refresh(int x,int y,char* str)
{
	if(m_pWnd==NULL) return;
	if(!str) return;

	int		i, pos, map, ch,
			size	= strlen(str),
			w		= size*24,
			h		= 48;

	pos=size; for(i=0;i<size;i++) if(str[i]=='.') pos--; w=pos*24;
	for(i=0,pos=0;i<size;i++)
	{
		// bitblt
		ch = str[i];
		map = MapIndex(ch);
		switch(ch)
		{
		case '.':
			if(i==0) m_MemDC.BitBlt(0+pos*24, 0, 24, 48, &m_MemDCFND, map*24, m_Color*48, SRCCOPY), pos++;
			else m_MemDC.BitBlt(0+(pos-1)*24+21, 0+43, 3, 3, &m_MemDCFND, map*24+21, m_Color*48+43, SRCCOPY);
			break;
		default:
			m_MemDC.BitBlt(0+pos*24, 0, 24, 48, &m_MemDCFND, map*24, m_Color*48, SRCCOPY);
			pos++;
			break;
		}
	}

	m_pDC->BitBlt(x, y, w, h, &m_MemDC, 0, 0, SRCCOPY);
}

void CFNDDisplay::Unit(int x,int y,LPCTSTR str)
{
	if(m_pWnd==NULL) return;
	if(!str) return;

	COLORREF color = m_pDC->GetTextColor();
	COLORREF bkcolor = m_pDC->GetBkColor();

	m_pDC->SetBkColor(RGB(0,0,0));
	m_pDC->SetTextColor(RGB(255,255,255));
	m_pDC->TextOut(x, y, str);
	m_pDC->SetTextColor(color);
	m_pDC->SetBkColor(bkcolor);
}
