// LEDDisplay.cpp: implementation of the CLEDDisplay class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TZSeries.h"
#include "LEDDisplay.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CLEDDisplay::CLEDDisplay()
{
	m_pWnd = NULL;
	m_Mode = 0;
}

CLEDDisplay::~CLEDDisplay()
{
	Close();
}

void CLEDDisplay::Close()
{
	if(!m_pWnd) return;

	m_Mode = 0;
	m_MemDCLED.SelectObject(m_pOldBitmapLED);
	m_MemDC.SelectObject(m_pOldBitmap);
	m_pWnd->ReleaseDC(m_pDC);

	m_pWnd = NULL;
}

CLEDDisplay::SetFrame(CWnd *pWnd)
{
	m_pWnd = NULL;

	// ----
	m_pWnd = pWnd;
	m_pDC = m_pWnd->GetDC();
	m_pWnd->GetClientRect(m_Rect);

	m_MemDC.CreateCompatibleDC(m_pDC);
	m_Bitmap.CreateCompatibleBitmap(m_pDC, m_Rect.Width(), m_Rect.Height());
	m_pOldBitmap = (CBitmap*)m_MemDC.SelectObject(&m_Bitmap);

	m_MemDCLED.CreateCompatibleDC(&m_MemDC);
	m_BitmapLED.LoadBitmap(IDB_BITMAP_LED);
	m_pOldBitmapLED = (CBitmap*)m_MemDCLED.SelectObject(&m_BitmapLED);
}

void CLEDDisplay::Refresh(int x,int y,int mode)
{
	if(m_pWnd==NULL) return;

//	m_MemDC.BitBlt(0, 0, 24, 24, &m_MemDCLED, mode*24, 0, SRCCOPY);
//	m_pDC->BitBlt(x, y, 24, 24, &m_MemDC, 0, 0, SRCCOPY);
	m_MemDC.BitBlt(0, 0, 24, 6, &m_MemDCLED, mode*24, 24, SRCCOPY);
	m_pDC->BitBlt(x, y, 24, 6, &m_MemDC, 0, 0, SRCCOPY);
}
