// TZSeriesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TZSeries.h"
#include "TZSeriesDlg.h"


#include "bcc.h"


#define	TZN_SEND_PACKET_SIZE_RX		9
#define	TZN_SEND_PACKET_SIZE_WX		14
#define TZN_RECEIVE_PACKET_SIZE_RD	16
#define TZN_RECEIVE_PACKET_SIZE_WD	15


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTZSeriesDlg dialog

CTZSeriesDlg::CTZSeriesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTZSeriesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTZSeriesDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTZSeriesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTZSeriesDlg)
	DDX_Control(pDX, IDC_STATIC_ETXBCC, m_ETXBCC);
	DDX_Control(pDX, IDC_STATIC_FRONT, m_Frame);
	DDX_Control(pDX, IDC_EDIT_SEND_MESSAGE, m_SendMsg);
	DDX_Control(pDX, IDC_EDIT_RECEIVE_MESSAGE, m_ReceiveMsg);
	DDX_Control(pDX, IDC_COMBO_ADDR, m_AddrList);
	DDX_Control(pDX, IDC_CHECK_PNP, m_PNP);
	DDX_Control(pDX, IDC_CHECK_AUTO, m_Auto);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTZSeriesDlg, CDialog)
	//{{AFX_MSG_MAP(CTZSeriesDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_BN_CLICKED(IDC_CHECK_AUTO, OnCheckAuto)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_STATIC_FRONT, OnStaticFront)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTZSeriesDlg message handlers

BOOL CTZSeriesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//    ʱȭ
	m_Comm_Port = 0;		// COM1
	m_Comm_Baudrate = 6;	// 9600
	m_Comm_ParityBit = 0;	// NOPARITY
	m_Comm_DataBit = 1;		// 8
	m_Comm_StopBit = 0;		// ONESTOPBIT

	// fnd ʱȭ
	m_FND.SetFrame(&m_Frame);
	m_FND.SetColor(1);

	// PV/SV ǥ  ʱȭ
	sprintf(m_PV_Value,"%5.0f",0);
	sprintf(m_SV_Value,"%5.0f",0);

	// led ʱȭ
	m_LED.SetFrame(&m_Frame);
	m_LED.SetMode(2);

	// ȭ鿡 ǥ Dialog item ʱȭ
	m_Auto.SetCheck(1);
	m_PNP.SetCheck(1);
	OnCheckAuto();

	//    ʱȭ
	Init();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTZSeriesDlg::Init()
{
	DWORD baudrate_map[15] = {	CBR_110,CBR_300,CBR_600,CBR_1200,CBR_2400,
								CBR_4800,CBR_9600,CBR_14400,CBR_19200,CBR_38400,
								CBR_56000,CBR_57600,CBR_115200,CBR_128000,CBR_256000 };
	BYTE databit_map[2] = {7,8};
	BYTE stopbit_map[2] = {ONESTOPBIT,TWOSTOPBITS};
	BYTE paritybit_map[3] = {NOPARITY,ODDPARITY,EVENPARITY};

	if(!m_comm.Open(m_Comm_Port+1,
				baudrate_map[m_Comm_Baudrate],
				databit_map[m_Comm_DataBit],
				paritybit_map[m_Comm_ParityBit],
				stopbit_map[m_Comm_StopBit]))
	{
		CString str;
		str.Format("COM%d can't open!", m_Comm_Port+1);
		AfxMessageBox(str);
	}


	memset(m_Addr, 0, sizeof(char)*TZ_MAX_NUM);
	for(int i=0;i<TZ_MAX_NUM;i++)
		m_Addr[i] = -1;

	m_AddrCurrIndex = 0;
	m_AddrRequest = -1;
	m_MaxNum = 0;

	m_Request = FALSE;
	m_MainRequest = TRUE;
}

void CTZSeriesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTZSeriesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// ȭ鿡 FND 
		m_FND.SetColor(0);
		m_FND.Refresh(73,34,m_PV_Value);
		m_FND.SetColor(1);
		m_FND.Refresh(73,95,m_SV_Value);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTZSeriesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTZSeriesDlg::OnButtonSend() 
{
	// TODO: Add your control notification handler code here
	BYTE msg[64];
	BYTE buf[64];
	char out[64];
	CString str;
	int packet_size;


	// ޸ ʱȭ
	memset(msg,0xff,64);
	memset(buf,0xff,64);

	// Էâκ  б
	m_SendMsg.GetWindowText(str);
	sprintf((char*)msg,"\002%s\003 ",(LPCTSTR)str);

	// RX/WX 쿡 
	if( !memcmp(msg+3,"RX",2) )		// 9="S01RXP0EB"
		packet_size = TZN_SEND_PACKET_SIZE_RX;
	else
	if( !memcmp(msg+3,"WX",2) )		// 14="S01WXS0-0123EB"
		packet_size = TZN_SEND_PACKET_SIZE_WX;
	else
		return;

	// TX LED ѱ
	m_LED.Refresh(4,143,1);

	// Ŷ   о
	m_comm.Read(msg, 60);			// dummy read

	// BCC
	msg[packet_size-1] = BCC_packet(msg+0, packet_size-1);

	// BCC ȭ鿡 ǥ
	sprintf(out, "ETX,%02X", msg[packet_size-1]);
	m_ETXBCC.SetWindowText(out);

	// Ŷο 
	m_comm.Write(msg, packet_size+15);// write

	// TX/RX LED 
	m_LED.Refresh(4,143,2);
	m_LED.Refresh(4,149,2);

	//  ٸ
	Sleep(600);						// wait

	// Ŷ б
	ReadPacket();					// read
}

int CTZSeriesDlg::SendPacket(int addr, int read_mode)
{
	BYTE msg[64];
	char out[64];

	//  Ŷ б
	m_comm.Read(msg, 60);

	// TX LEDѱ
	m_LED.Refresh(4,143,1);
	memset(msg,0xff,64);

	if(read_mode)
	{
		// SV б Ŷ 
		sprintf((char*)msg,"\002%02dRXS0\003 ", addr);
	}
	else
	{
		// PV б Ŷ 
		sprintf((char*)msg,"\002%02dRXP0\003 ", addr);
	}

	// BCC
	msg[8] = BCC_packet(msg+0, 8);

	// Ŷ ȭ鿡 ǥ
	sprintf(out, "ETX,%02X", msg[8]);
	m_ETXBCC.SetWindowText(out);

	memcpy(out, msg+1, 6);
	out[6]=0;
	m_SendMsg.SetWindowText(out);

	// Ŷο Ŷ 
	m_comm.Write(msg, TZN_SEND_PACKET_SIZE_RX+15);		// write

	// TX/RX LED
	m_LED.Refresh(4,143,2);
	m_LED.Refresh(4,149,2);

	return 1;
}

int CTZSeriesDlg::ReadPacket()
{
	char out[32];
	CString str;
	int i, len;
	BYTE packet[64];
	int packet_size;
	static int dot=0;


	// Ŷ б
	len = m_comm.Read(packet, 60);

	// Ŷ 簪 ǥ
	for(i=0;i<len;i++)
	{
		sprintf(out,"%02X ", packet[i]);
		str += out;
	}
	m_ReceiveMsg.SetWindowText(str);


	// BCC˻
	if( len>=TZN_RECEIVE_PACKET_SIZE_WD )
	{
		//  
		float a;
		long exp;
		int k, sign, digit, addr, index, code;


		// ACKȣ ˻
		if(packet[0]!=0x06) return 0;			// ACK(0x06)

		// STXȣ ˻
		if(packet[1]!=0x02) return 0;			// STX(0x02)

		// Command ˻
		if( !memcmp(packet+4,"RD",2) )				// "RD"
		{
			packet_size = TZN_RECEIVE_PACKET_SIZE_RD;
		}
		else
		if( !memcmp(packet+4,"WD",2) )				// "WD"
		{
			packet_size = TZN_RECEIVE_PACKET_SIZE_WD;
		}
		else
			return 0;

		// Code ã
		if(!memcmp(packet+6,"P0",2))				// "P0"
			code = 0;
		else
		if(!memcmp(packet+6,"S0",2))				// "S0"
			code = 1;
		else
			return 0;

		if(BCC_packet(packet+0, packet_size-1)!=packet[packet_size-1])
			return FALSE;

		// (address) 
		addr = (packet[2]-'0')*10 + (packet[3]-'0');
		if(addr<=0 || addr>=TZ_MAX_NUM) return FALSE;

		// RX LED ѱ
		m_LED.Refresh(4,149,1);

		// ȣ(sign) 
		sign = packet[8]=='-' ? -1 : 1;

		// Value 
		digit = 5;
		if(!code)
		{
			dot = packet[13]-'0';
		}
		if(dot) digit++;
		a = 0;
		exp=1000;
		for(k=0;k<4;k++)
		{
			a += (packet[k+9]-'0') * exp;
			exp /= 10;
		}
		for(k=0;k<dot;k++)
			a /= 10;
		a *= sign;

		// PNP
		PNPList(addr, TRUE);

		// ȭ ǥ
		str.Format("%02d",addr);
		index = m_AddrList.FindString(0,(LPCTSTR)str);
		if(index==m_AddrList.GetCurSel() )
		{
			if(code==0)	// P0
			{
				m_FND.SetColor(0);
				sprintf(m_PV_Value, "%*.*f", digit, dot, a);
				m_FND.Refresh(73,34,m_PV_Value);
			}
			else		// S0
			{
				// 06 02 30 31 57 44 53 30 2D 30 31 32 32 03 5A
				// AS01WDS0-01233
				m_FND.SetColor(1);
				sprintf(m_SV_Value, "%*.*f", digit, dot, a);
				m_FND.Refresh(73,95,m_SV_Value);
			}
		}

		return code+1;
	}
	else
	{
		// PNP
		PNPList(m_AddrRequest, FALSE);

		// RX ȲLEDѱ
		m_LED.Refresh(4,149,3);
	}

	return 0;
}

void CTZSeriesDlg::PNPList(int addr, int stat)
{
	CString str;
	str.Format("%02d",addr);
	int index;

	// LIST ش addr˻
	index = m_AddrList.FindString(0,(LPCTSTR)str);

	// addr   
	if(addr<=0 || addr>=TZ_MAX_NUM)
		return;

	// LIST ε  
	if(index==CB_ERR)
	{
		// Ͽ ߰
		if(stat)
		{
			// add list
			m_Addr[addr] = addr;
			m_AddrList.AddString(str);
			if(m_AddrList.GetCurSel()<0)
				m_AddrList.SetCurSel( m_AddrList.FindString(0,(LPCTSTR)str) );
		}
	}

	// LIST ε  
	else
	{
		// Ͽ 
		if(!stat)
		{
			// delete list
			m_Addr[addr] = -1;
			m_AddrList.DeleteString(index);
			m_AddrList.SetCurSel(0);
		}
	}

	m_MaxNum = m_AddrList.GetCount();
}

void CTZSeriesDlg::Pause()
{
	KillTimer(0);
}

// Autoscan  Ǿ  ȣ!
void CTZSeriesDlg::Restart()
{
	SetTimer(0, 600, NULL);

	m_Request = FALSE;
	m_MainRequest = TRUE;
}

void CTZSeriesDlg::OnCheckAuto() 
{
	CButton* pSendBtn = (CButton*)GetDlgItem(IDC_BUTTON_SEND);
	CEdit* pSendEdit = (CEdit*)GetDlgItem(IDC_EDIT_SEND_MESSAGE);
	CEdit* pPNPEdit = (CEdit*)GetDlgItem(IDC_CHECK_PNP);

	// TODO: Add your control notification handler code here
	// Autoscan  б
	int stat = m_Auto.GetCheck();

	// üũ  ִٸ
	if( stat )
	{
		// 簳
		Restart();
		// Dialog item Disable/Enable 
		pSendBtn->EnableWindow(FALSE);
		pSendEdit->EnableWindow(FALSE);
		pPNPEdit->EnableWindow(TRUE);
	}
	else
	{
		// 
		Pause();
		// Dialog item Disable/Enable 
		pSendBtn->EnableWindow(TRUE);
		pSendEdit->EnableWindow(TRUE);
		pPNPEdit->EnableWindow(FALSE);
	}
}

void CTZSeriesDlg::OnTimer(UINT nIDEvent) 
{
	CString str;
	int pnp, read_sv_pv=0;
	static int read_mode=1;


	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent) {
	case 0:
		// û ̸
		if(!m_Request)
		{
			pnp = m_PNP.GetCheck();
			// PNPó
			if(pnp)
			{
				if(m_MainRequest && m_MaxNum)
				{
					m_AddrList.GetWindowText(str);
					m_AddrRequest = atoi(str);
					m_MainRequest = FALSE;
					read_mode = !read_mode;
					read_sv_pv = 1;
				}
				else
				{
					m_AddrCurrIndex++;
					if(m_AddrCurrIndex>=TZ_MAX_NUM) m_AddrCurrIndex=1;
					m_AddrRequest = m_AddrCurrIndex;
					m_MainRequest = TRUE;
				}
			}
			else
			{
				m_AddrList.GetWindowText(str);
				m_AddrRequest = atoi(str);
				read_mode = !read_mode;
				read_sv_pv = 1;
			}

			SendPacket( m_AddrRequest, read_sv_pv & read_mode);

			m_Request = TRUE;
		}

		//  ̸
		else
		{
			// Ŷ б
			ReadPacket();
			m_Request = FALSE;
		}
		break;

	default:
		break;
	}

	// ȭ鿡 FND 
	m_FND.SetColor(0);
	m_FND.Refresh(73,34,m_PV_Value);
	m_FND.SetColor(1);
	m_FND.Refresh(73,95,m_SV_Value);

	CDialog::OnTimer(nIDEvent);
}

void CTZSeriesDlg::Close()
{
	// Autoscan϶ Ÿ̸Ӹ 
	KillTimer(0);
	// Ŷ 
	m_comm.Close();
}

BOOL CTZSeriesDlg::DestroyWindow() 
{
	// ó
	Close();

	// FND ó
	m_FND.Close();

	// LED ó
	m_LED.Close();

	return CDialog::DestroyWindow();
}

#include "SetupDlg.h"
void CTZSeriesDlg::OnStaticFront() 
{
	CSetupDlg dlg;


	//  Ķ   ȭڷ 
	dlg.m_Port = m_Comm_Port;
	dlg.m_BaudRate = m_Comm_Baudrate;
	dlg.m_DataBit = m_Comm_DataBit;
	dlg.m_ParityBit = m_Comm_ParityBit;
	dlg.m_StopBit = m_Comm_StopBit;
	if(dlg.DoModal()==IDOK)
	{
		// Ŷ  ȭ ִٸ
		if(	m_Comm_Port != dlg.m_Port ||
			m_Comm_Baudrate != dlg.m_BaudRate ||
			m_Comm_DataBit != dlg.m_DataBit ||
			m_Comm_ParityBit != dlg.m_ParityBit ||
			m_Comm_StopBit != dlg.m_StopBit )
		{
			//  
			m_Comm_Port = dlg.m_Port;
			m_Comm_Baudrate = dlg.m_BaudRate;
			m_Comm_DataBit = dlg.m_DataBit;
			m_Comm_ParityBit = dlg.m_ParityBit;
			m_Comm_StopBit = dlg.m_StopBit;

			// ó
			Close();

			// ʱȭ
			Init();

			// Autoscan 
			if(m_Auto.GetCheck())
				Restart();
		}
	}
}
